--- pfqueue.c.orig	2005-01-02 19:40:24.073521792 +0100
+++ pfqueue.c	2005-01-02 20:11:23.503150680 +0100
@@ -3,6 +3,8 @@
 #include <ncurses.h>
 #include <unistd.h>
 #include <sys/stat.h>
+#include <sys/types.h>
+#include <dirent.h>
 #include <stdlib.h>
 #include <string.h>
 
@@ -141,65 +143,42 @@
 	return ( b );
 }
 
+int fill_list_do (const char *path) {
+	DIR *dirp;
+	struct dirent *dp;
+	char const *entry;
+	char b[BUF_SIZE];
+
+	dirp = opendir (path);
+	if (dirp == NULL)
+		return -1;
+
+	while ( NUMMSG < MSG_MAX && ((dp = readdir (dirp)) != NULL) )  {
+		entry = dp->d_name;
+		/* Skip "." ".." and "" (Returned by Slowlaris 2.4 on NFS *g*) */
+		if (dp->d_type == DT_DIR && 
+		    (entry[entry[0] != '.' ? 0 : entry[1] != '.' ? 1 : 2] != '\0')) {
+			snprintf( b, BUF_SIZE, "%s/%s/%s", queue_path, q_names[CURQ], entry );
+			fill_list_do( b );
+		} else if (dp->d_type == DT_REG) {
+			queue[NUMMSG].cached = 0;
+			strncpy(queue[NUMMSG].id, entry, sizeof(queue[NUMMSG].id));
+			NUMMSG++;
+		}
+	}
+	closedir( dirp );
+	return 0;
+}
+
 // Fills the list of messages
 void fill_list () {
 	FILE *p;
 	char b[BUF_SIZE];
 
-#ifndef HAS_FIND_PRINTF
-	char t[2048];
-	char *c;
-#endif
-
-#ifdef HAS_FIND_PRINTF
-#ifdef HAS_HEAD
-	snprintf ( b, BUF_SIZE, "find %s/%s -type f -printf '%%f\\n' | head -n %d",
-		queue_path,
-		q_names[CURQ],
-		MSG_MAX );
-#else
-	snprintf ( b, BUF_SIZE, "find %s/%s -type f -printf '%%f\\n'",
-		queue_path,
-		q_names[CURQ]);
-#endif // HAS_HEAD
-#endif // HAS_FIND_PRINTF
-
-#ifndef HAS_FIND_PRINTF
-#ifdef HAS_HEAD
-	snprintf ( b, BUF_SIZE, "find %s/%s -type f | head -n %d",
-		queue_path,
-		q_names[CURQ],
-		MSG_MAX );
-#else
-	snprintf ( b, BUF_SIZE, "find %s/%s -type f",
-		queue_path,
-		q_names[CURQ]);
-#endif // HAS_HEAD
-#endif // !HAS_FIND_PRINTF
-
-	p = popen ( b, "r" );
+	snprintf(b, BUF_SIZE, "%s/%s", queue_path, q_names[CURQ] );
 
 	NUMMSG = 0;
-
-	if ( !p )
-		return;
-
-#ifdef HAS_FIND_PRINTF
-	while ( NUMMSG<MSG_MAX && freadl ( p, queue[NUMMSG].id, sizeof(queue[NUMMSG].id) ) ) {
-		queue[NUMMSG].cached = 0;
-		NUMMSG++;
-	}
-#endif
-
-#ifndef HAS_FIND_PRINTF
-	while ( NUMMSG<MSG_MAX && freadl ( p, t, sizeof(t) ) ) {
-		queue[NUMMSG].cached = 0;
-		c = strrchr(t, '/' );
-		strncpy ( queue[NUMMSG].id, c+sizeof(char), 11 );
-		NUMMSG++;
-	}
-#endif
-	pclose ( p );
+	fill_list_do( b );
 }
 
 // Extracts and header from the message
@@ -616,7 +595,6 @@
 			goto no_fill;
 			break;
 		}
-		
 	}
 }
 
